include <glow-v2-defines.scad>

module cell(){
    difference(){
        cube(size=[celld+2*walld, celld+2*walld, 25+walld]);
        translate([walld,-2*walld,-1]) cube(size=[celld,celld+3*walld,30]);
    }
}

difference(){
    cube(size=[boxw,boxd,boxh]);
    
    difference(){
        translate([walld,walld,walld])cube(size=[boxw,boxd,boxh]);
        translate([boxw-23.2-17.25,walld-0.1,walld-0.1]) cube(size=[7.5,2.75,7.5]);
        translate([boxw-17.25,walld-0.1,walld-0.1]) cube(size=[7.5,2.75,7.5]);       
    }
    
    translate([boxw-10,0,walld+1]){
        //Screws for the PCB//
        translate([-3.5-23.2,0,3.5]) rotate([90,0,0]) cylinder(r=M3, h=20, center=true, $fn=cfn);
        translate([-3.5-23.2,0,3.5+37.5]) rotate([90,0,0]) cylinder(r=M3, h=5, center=true, $fn=cfn);
        translate([-3.5,0,3.5]) rotate([90,0,0]) cylinder(r=M3, h=20, center=true, $fn=cfn);
 
        // Pins for I/O for the CCD //       
        translate([-21.2,0,38.2]){
            translate([0,0,0]) rotate([90,0,0]) cylinder(r=pinr, h=5, center=true, $fn=6);
            translate([0,0,0-2.54]) rotate([90,0,0]) cylinder(r=pinr, h=5, center=true, $fn=6);
            translate([0,0,0-5.08]) rotate([90,0,0]) cylinder(r=pinr, h=5, center=true, $fn=6);
            translate([0,0,0-7.62]) rotate([90,0,0]) cylinder(r=pinr, h=5, center=true, $fn=6);
            translate([0,0,0-10.16]) rotate([90,0,0]) cylinder(r=pinr, h=5, center=true, $fn=6);
            translate([0,0,0-12.7]) rotate([90,0,0]) cylinder(r=pinr, h=5, center=true, $fn=6);
        }
    }    
    //Screws opposing magnets //
    //translate([0,boxd-6,7]) rotate([0,90,0]) cylinder(r=M3, h=10, center=true, $fn=cfn);
    translate([0,boxd-6,45]) rotate([0,90,0]) cylinder(r=M3, h=10, center=true, $fn=cfn);
    translate([boxw-6,boxd-6,0]) cylinder(r=M3-0.3, h=20, center=true, $fn=cfn);
    translate([8,boxd-6,0]) cylinder(r=M3-0.3, h=20, center=true, $fn=cfn);
}
//Light trap//
translate([0,boxd-walld*2,walld]) cube(size=[boxw-walld,walld,walld]);
translate([boxw-2*walld,0,walld]) cube(size=[walld,boxd-walld,walld]);
translate([boxw-2*walld,walld,0]) cube(size=[walld,walld,boxh]);
translate([walld,boxd-2*walld,0]) cube(size=[walld,walld,boxh]);

p1 = [0,0];
p2 = [4,0];
p3 = [0,3];

translate([0,0,boxh]) rotate([0,90,0])linear_extrude(height=boxw-walld, convexity = 10) 
			polygon(points = [p1, p2, p3], convexity = 10);
translate([0,boxd-walld,boxh]) rotate([0,90,-90])linear_extrude(height=boxd-walld, convexity = 10) 
			polygon(points = [p3, p2, p1], convexity = 10);


//Extra plastic for bottom screws//
        translate([boxw-6-2*walld,boxd-6-2*walld,0]){
            difference(){
                cube(size=[6,6,2*walld]);
                translate([3,3,0])cylinder(r=M3-0.3, h=20, center=true, $fn=cfn);
            }
        }
        translate([8-2*walld,boxd-6-2*walld,0]){
            difference(){
                cube(size=[6,6,2*walld]);
                translate([3,3,0])cylinder(r=M3-0.3, h=20, center=true, $fn=cfn);
            }
        }

//Spectroscopic cell holder//
translate([boxw-31.2+walld,ccdoffset,0])cell();